/*

 methods_3
 questo sorgente e' parte integrante 
 del Progetto xSudoky.
 Scritto da Max Cavallo 20/Luglio/2007
 ixamit@gmail.com

*/

#include "sudoky.h"
#include <libintl.h>
#include <locale.h>

int label_Tipo;
//====================================================
//
//-------------------------FISH ----------------------
//
//====================================================

int MessaggioXWing (int Candidato,int rows_pos,int cols_pos)
{
	char Row[3],Col[3];
	strcpy (Row,GetCandidati2(rows_pos));
	strcpy (Col,GetCandidati2(cols_pos));

	sprintf (BUFF,
		gettext("  Found [%d] in R%cC%c, R%cC%c, R%cC%c, R%cC%c"),
		Candidato,
		Row[0],Col[0],
		Row[0],Col[1],
		Row[1],Col[0],
		Row[1],Col[1]);

	AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);

	return (0);
}

int CancellaXWing (int Tipo,int Candidato,int bit_pos1,int bit_pos2)
{
	// Attenzione
	// Tipo == 1 su righe
	// Tipo == 2 su colonne
	// bit_pos2 corrisponde alle Righe o Colonne
	// su cui eliminare il possibile candidato
	//
	int y,x;
	int count=0;

	if (Tipo==1)
	{
		// Righe
		for (y=0;y<SUD_TAB;y++)
		{
			if ((bit_pos1 & (1<<y))==0)
			{
				for (x=0;x<SUD_TAB;x++)
				{
					if ((bit_pos2 & (1<<x) &&
					(SUD_BUF[y][x] & (1<<(Candidato-1)))))
					{
						if (label_Tipo++==0)
						{
							AddItemListCmd (ViewComment, LABEL,
							gettext("X-WING ROW"),NULL);
						}

						if (++count==1)
							MessaggioXWing (
								Candidato,
								bit_pos1,
								bit_pos2);

						
						sprintf (BUFF,
						gettext("    Unset [%d] in R%dC%d"),
						Candidato,y+1,x+1);

						AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);

						RemoveCandidatoGUI(y,x,Candidato,0);
					}
				}
			}
		}
	}
	if (Tipo==2)
	{
		// Colonne
		for (x=0;x<SUD_TAB;x++)
		{
			if ((bit_pos1 & (1<<x))==0)
			{
				for (y=0;y<SUD_TAB;y++)
				{
					if ((bit_pos2 & (1<<y) &&
					(SUD_BUF[y][x] & (1<<(Candidato-1)))))
					{
						if (label_Tipo++==0)
						{
							AddItemListCmd (ViewComment, LABEL,
							gettext("X-WING COLUMN"),NULL);
						}

						if (++count==1)
							MessaggioXWing (
								Candidato,
								bit_pos2,
								bit_pos1);

						
						sprintf (BUFF,
						gettext("    Unset [%d] in R%dC%d"),
						Candidato,y+1,x+1);

						AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);

						RemoveCandidatoGUI(y,x,Candidato,0);
					}
				}
			}
		}
	}

	return (0);
}

int VerificaXWing (int Tipo,int Candidato,int tmp[SUD_TAB])
{
	char *DecToBin(char *pSave,int   n);

	int k,z;
	int posizioni;
	
	for (k=0;k<SUD_TAB;k++)
	{
		posizioni=0x0;
		if (ContaBits (tmp[k])==2)
		{
			for (z=k+1;z<SUD_TAB;z++)
			{
				if (ContaBits (tmp[z])==2 && tmp[k]==tmp[z])
				{
					posizioni|=1 << k;
					posizioni|=1 << z;
						
					CancellaXWing (Tipo,Candidato,posizioni,tmp[k]);
				}
			}
		}
	}
	
	return 0;
}

int XWingRighe()
{
	int x,y,k;
	int tmp[SUD_TAB];

	for (k=0;k<SUD_TAB;k++)
	{
		for (y=0;y<SUD_TAB;y++)
		{
			tmp[y]=0x0;
			for (x=0;x<SUD_TAB;x++)
			{
				if (SUD_BUF[y][x] & (1 << k))
				{
					if (IsCandi (y,x))
						tmp[y] |= (1 << x);
				}
			}
		}
		VerificaXWing(1,k+1,tmp);	
	}
	label_Tipo=0;
	return (0);
}

int XWingColonne()
{
	int x,y,k;
	int tmp[SUD_TAB];

	for (k=0;k<SUD_TAB;k++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			tmp[x]=0x0;
			for (y=0;y<SUD_TAB;y++)
			{
				if (SUD_BUF[y][x] & (1 << k))
				{
					if (IsCandi (y,x))
						tmp[x] |= (1 << y);
				}
			}
		}
		VerificaXWing(2,k+1,tmp);	
	}
	label_Tipo=0;
	return (0);
}

int XWing ()
{
	Clear_Comments ();
	//AddItemListCmd (ViewComment, LABEL,
	//gettext("X-WING") , NULL);

	XWingRighe();
	XWingColonne();

	SudoFinish(SOLVE);

	return (0);
}


